package battlenet

import (
	"fmt"

	"wartank/pkg/components/sectionnet"
	"wartank/pkg/types"
)

/*
	Автоматически воюет в сражении
*/

// BattleNet -- танкует в сражении
type BattleNet struct {
	*sectionnet.SectionNet
	server types.IServer
	bot    types.IServBot
}

// NewBattleNet -- возвращает новый *BattleNet
func NewBattleNet(server types.IServer, bot types.IServBot) (*BattleNet, error) {
	{ // Предусловия
		if server == nil {
			return nil, fmt.Errorf("NewBattleNet(): IServer == nil")
		}
		if bot == nil {
			return nil, fmt.Errorf("NewBattleNet(): IServBot == nil")
		}
	}

	sf := &BattleNet{
		server: server,
		bot:    bot,
	}
	return sf, nil
}

// Запусает сеть в работу
func (sf *BattleNet) Run() {
	sf.SectionNet = sectionnet.NewSectionNet(sf.server, sf.bot, sf.bot.Angar().Battle(), "http://wartank.ru/pve")
}
